/*
 * This file is public domain.
 *
 * Author: Petri Nordlund <petrin@megabaud.fi>
 *
 * $Id: defs.h 1.3 1995/10/05 12:31:38 petrin Exp petrin $
 *
 */

/* EXEC/TYPES.H */
#include <exec/types.h>


/* SYSTEM */
#include <exec/memory.h>
#include <exec/ports.h>
#include <exec/execbase.h>
#include <exec/tasks.h>
#include <dos/dos.h>


#ifdef USE_MULTIUSER
#include <libraries/multiuser.h>
#endif


/* PROTOS */
#include <proto/exec.h>
#ifdef USE_MULTIUSER
#include <proto/multiuser.h>
#endif
#include <proto/dos.h>
#include <proto/utility.h>


/* ANSI C */
#include <stdio.h>
#include <string.h>
#include <stdlib.h>


/* General macros */
#ifndef max
#define   max(a,b)    ((a) > (b) ? (a) : (b))
#endif
#ifndef min
#define   min(a,b)    ((a) <= (b) ? (a) : (b))
#endif
