#ifndef _INLINE_SYSINFO_H
#define _INLINE_SYSINFO_H

#include <sys/cdefs.h>
#include <inline/stubs.h>

__BEGIN_DECLS

#ifndef BASE_EXT_DECL
#define BASE_EXT_DECL
#define BASE_EXT_DECL0 extern struct Library * SysInfoBase;
#endif
#ifndef BASE_PAR_DECL
#define BASE_PAR_DECL
#define BASE_PAR_DECL0 void
#endif
#ifndef BASE_NAME
#define BASE_NAME SysInfoBase
#endif

BASE_EXT_DECL0

extern __inline struct SI_Notify *
AddNotify (BASE_PAR_DECL struct SysInfo * si,WORD flags,LONG safety_limit)
{
  BASE_EXT_DECL
  register struct SI_Notify * _res  __asm("d0");
  register struct Library *a6 __asm("a6") = BASE_NAME;
  register struct SysInfo * a0 __asm("a0") = si;
  register WORD d0 __asm("d0") = flags;
  register LONG d1 __asm("d1") = safety_limit;
  __asm __volatile ("jsr a6@(-0x4e)"
  : "=r" (_res)
  : "r" (a6), "r" (a0), "r" (d0), "r" (d1)
  : "a0","a1","d0","d1", "memory");
  return _res;
}
extern __inline void 
FreeSysInfo (BASE_PAR_DECL struct SysInfo * si)
{
  BASE_EXT_DECL
  register struct Library *a6 __asm("a6") = BASE_NAME;
  register struct SysInfo * a0 __asm("a0") = si;
  __asm __volatile ("jsr a6@(-0x24)"
  : /* no output */
  : "r" (a6), "r" (a0)
  : "a0","a1","d0","d1", "memory");
}
extern __inline void 
GetCpuUsage (BASE_PAR_DECL struct SysInfo * si,struct SI_CpuUsage * usage)
{
  BASE_EXT_DECL
  register struct Library *a6 __asm("a6") = BASE_NAME;
  register struct SysInfo * a0 __asm("a0") = si;
  register struct SI_CpuUsage * a1 __asm("a1") = usage;
  __asm __volatile ("jsr a6@(-0x5a)"
  : /* no output */
  : "r" (a6), "r" (a0), "r" (a1)
  : "a0","a1","d0","d1", "memory");
}
extern __inline void 
GetLoadAverage (BASE_PAR_DECL struct SysInfo * si,struct SI_LoadAverage * la)
{
  BASE_EXT_DECL
  register struct Library *a6 __asm("a6") = BASE_NAME;
  register struct SysInfo * a0 __asm("a0") = si;
  register struct SI_LoadAverage * a1 __asm("a1") = la;
  __asm __volatile ("jsr a6@(-0x2a)"
  : /* no output */
  : "r" (a6), "r" (a0), "r" (a1)
  : "a0","a1","d0","d1", "memory");
}
extern __inline LONG 
GetNice (BASE_PAR_DECL struct SysInfo * si,LONG which,LONG who)
{
  BASE_EXT_DECL
  register LONG  _res  __asm("d0");
  register struct Library *a6 __asm("a6") = BASE_NAME;
  register struct SysInfo * a0 __asm("a0") = si;
  register LONG d0 __asm("d0") = which;
  register LONG d1 __asm("d1") = who;
  __asm __volatile ("jsr a6@(-0x42)"
  : "=r" (_res)
  : "r" (a6), "r" (a0), "r" (d0), "r" (d1)
  : "a0","a1","d0","d1", "memory");
  return _res;
}
extern __inline LONG 
GetPgrp (BASE_PAR_DECL struct SysInfo * si)
{
  BASE_EXT_DECL
  register LONG  _res  __asm("d0");
  register struct Library *a6 __asm("a6") = BASE_NAME;
  register struct SysInfo * a0 __asm("a0") = si;
  __asm __volatile ("jsr a6@(-0x3c)"
  : "=r" (_res)
  : "r" (a6), "r" (a0)
  : "a0","a1","d0","d1", "memory");
  return _res;
}
extern __inline LONG 
GetPid (BASE_PAR_DECL struct SysInfo * si)
{
  BASE_EXT_DECL
  register LONG  _res  __asm("d0");
  register struct Library *a6 __asm("a6") = BASE_NAME;
  register struct SysInfo * a0 __asm("a0") = si;
  __asm __volatile ("jsr a6@(-0x30)"
  : "=r" (_res)
  : "r" (a6), "r" (a0)
  : "a0","a1","d0","d1", "memory");
  return _res;
}
extern __inline LONG 
GetPpid (BASE_PAR_DECL struct SysInfo * si)
{
  BASE_EXT_DECL
  register LONG  _res  __asm("d0");
  register struct Library *a6 __asm("a6") = BASE_NAME;
  register struct SysInfo * a0 __asm("a0") = si;
  __asm __volatile ("jsr a6@(-0x36)"
  : "=r" (_res)
  : "r" (a6), "r" (a0)
  : "a0","a1","d0","d1", "memory");
  return _res;
}
extern __inline LONG 
GetTaskCpuUsage (BASE_PAR_DECL struct SysInfo * si,struct SI_TaskCpuUsage * usage,struct Task * task)
{
  BASE_EXT_DECL
  register LONG  _res  __asm("d0");
  register struct Library *a6 __asm("a6") = BASE_NAME;
  register struct SysInfo * a0 __asm("a0") = si;
  register struct SI_TaskCpuUsage * a1 __asm("a1") = usage;
  register struct Task * a2 __asm("a2") = task;
  __asm __volatile ("jsr a6@(-0x60)"
  : "=r" (_res)
  : "r" (a6), "r" (a0), "r" (a1), "r" (a2)
  : "a0","a1","a2","d0","d1", "memory");
  return _res;
}
extern __inline struct SysInfo *
InitSysInfo (BASE_PAR_DECL0)
{
  BASE_EXT_DECL
  register struct SysInfo * _res  __asm("d0");
  register struct Library *a6 __asm("a6") = BASE_NAME;
  __asm __volatile ("jsr a6@(-0x1e)"
  : "=r" (_res)
  : "r" (a6)
  : "a0","a1","d0","d1", "memory");
  return _res;
}
extern __inline void 
RemoveNotify (BASE_PAR_DECL struct SysInfo * si,struct SI_Notify * notify)
{
  BASE_EXT_DECL
  register struct Library *a6 __asm("a6") = BASE_NAME;
  register struct SysInfo * a0 __asm("a0") = si;
  register struct SI_Notify * a1 __asm("a1") = notify;
  __asm __volatile ("jsr a6@(-0x54)"
  : /* no output */
  : "r" (a6), "r" (a0), "r" (a1)
  : "a0","a1","d0","d1", "memory");
}
extern __inline LONG 
SetNice (BASE_PAR_DECL struct SysInfo * si,LONG which,LONG who,LONG nice)
{
  BASE_EXT_DECL
  register LONG  _res  __asm("d0");
  register struct Library *a6 __asm("a6") = BASE_NAME;
  register struct SysInfo * a0 __asm("a0") = si;
  register LONG d0 __asm("d0") = which;
  register LONG d1 __asm("d1") = who;
  register LONG d2 __asm("d2") = nice;
  __asm __volatile ("jsr a6@(-0x48)"
  : "=r" (_res)
  : "r" (a6), "r" (a0), "r" (d0), "r" (d1), "r" (d2)
  : "a0","a1","d0","d1","d2", "memory");
  return _res;
}

#undef BASE_EXT_DECL
#undef BASE_EXT_DECL0
#undef BASE_PAR_DECL
#undef BASE_PAR_DECL0
#undef BASE_NAME

__END_DECLS

#endif /* _INLINE_SYSINFO_H */
